<?php

/**
 * Written by David Smith
 * nopeer@gmail.com
 *
 * For ATNF CSIRO
 *
 * This class represents the user data we wish to store in _SESSION.
 * This includes;
 * - The users email address
 * - The method of authenticate used 'anonymous' or 'opal'
 */

class UserData
{
  // PUBLIC

  public function __construct()
  {
    $this->auth_type = '';
    $this->email = '';
    $this->associated_projects = Array();
    $this->RestoreFromSession();
  }

  public function __destruct()
  {
    $this->SaveToSession();
  }

  public function SetAuthType( $s_auth_type ) { $this->auth_type = $s_auth_type; }
  public function GetAuthType() { return $this->auth_type; }

  public function SetEmail( $s_email ) { $this->email = $s_email; }
  public function GetEmail() { return $this->email; }
  
  public function GetAssociatedProjects() { return $this->associated_projects; }
  public function SetAssociatedProjects( $s_projects ) { $this->associated_projects = $s_projects; }

  public function RemoveFromSession()
  {
    global $_SESSION;

    unset( $_SESSION['userdata_email'] );
    unset( $_SESSION['userdata_auth_type'] );
    unset( $_SESSION['userdata_associated_projects'] );
    
    $this->email = '';
    $this->auth_type = '';
  }

  // PRIVATE

  private $auth_type;
  private $email;
  private $associated_projects;

  private function SaveToSession()
  {
    global $_SESSION;

    if( $this->auth_type != '' )
    {
      $_SESSION['userdata_auth_type'] = $this->auth_type;
      $_SESSION['userdata_email'] = $this->email;
      $_SESSION['userdata_associated_projects'] = $this->associated_projects;
    }
  }

  private function RestoreFromSession()
  {
    global $_SESSION;

    if( isset( $_SESSION['userdata_auth_type'] ) )
      $this->auth_type = $_SESSION['userdata_auth_type'];

    if( isset( $_SESSION['userdata_email'] ) )
      $this->email = $_SESSION['userdata_email'];
    
    if( isset( $_SESSION['userdata_associated_projects'] ) )
      $this->associated_projects = $_SESSION['userdata_associated_projects'];
  }
};

?>